<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/* Auto subscribe when order status completed */
$all_plugins = apply_filters('active_plugins', get_option('active_plugins'));
if (stripos(implode($all_plugins), 'woocommerce.php')) {
function g9_subke_order_completed( $order_id ) {
$kestatus = get_post_meta( $order_id, 'ke_status', true );
if( empty($kestatus) && get_option('g9kekey') && get_option('g9keuserid') && get_option('g9kewoolistid'))  {
$order = wc_get_order($order_id);
$data = $order->get_data();
$firstname = $data['billing']['first_name'];
$lastname = $data['billing']['last_name'];
$fullname = $firstname.' '.$lastname;
$email = $data['billing']['email'];
$url = 'https://api.kirim.email/v3/subscriber/';
$timestamp = time();
$api_username = get_option('g9keuserid');
$api_token = get_option('g9kekey');
$auth_str = rtrim(ltrim($api_username)) . "::" . rtrim(ltrim($api_token)) . "::" . $timestamp;
$token = hash_hmac("sha256", $auth_str, rtrim(ltrim($api_token)));   
$listid = get_option('g9kewoolistid');
    
        $bodydata = array(
        'lists' => $listid ,
        'full_name' => $fullname,
        'email' => $email
        );
        $bodydatatosend = http_build_query($bodydata) . "\n";   
        $request_args = array(
        'method' => 'POST',
        'sslverify' => false,
        'timeout' => 10,
        'httpversion' => '1.1',
        'body' => $bodydatatosend,
        'headers' => array(
                'Auth-Id' => $api_username,
                'Auth-Token' => $token,
                'Timestamp' => $timestamp,
                'Content-Type' => 'application/x-www-form-urlencoded'
            ),
        );
    $raw_response = wp_remote_request($url, $request_args);
            if (is_wp_error($raw_response)) {
            $request_args['sslverify'] = true;
            $raw_response = wp_remote_request($url, $request_args);

            if (is_wp_error($raw_response)) {
                return false;
            }
        }

        $json = wp_remote_retrieve_body($raw_response);
        $result = json_decode($json, true);
    if ($result['code'] == 200){
    update_post_meta($order_id, 'ke_status','success');
    }
}  
}
    

function g9_subke_order_change_to_completed( $order_id, $old_status, $new_status ) {
$kestatus = get_post_meta( $order_id, 'ke_status', true );
    if( $new_status == "completed" && empty($kestatus) && get_option('g9kekey') && get_option('g9keuserid') && get_option('g9kewoolistid')) {
$order = wc_get_order($order_id);
$data = $order->get_data();
$firstname = $data['billing']['first_name'];
$lastname = $data['billing']['last_name'];
$fullname = $firstname.' '.$lastname;
$email = $data['billing']['email'];
$url = 'https://api.kirim.email/v3/subscriber/';
$timestamp = time();
$api_username = get_option('g9keuserid');
$api_token = get_option('g9kekey');
$auth_str = rtrim(ltrim($api_username)) . "::" . rtrim(ltrim($api_token)) . "::" . $timestamp;
$token = hash_hmac("sha256", $auth_str, rtrim(ltrim($api_token)));   
$listid = get_option('g9kewoolistid');
    
        $bodydata = array(
        'lists' => $listid ,
        'full_name' => $fullname,
        'email' => $email
        );
        $bodydatatosend = http_build_query($bodydata) . "\n";   
        $request_args = array(
        'method' => 'POST',
        'sslverify' => false,
        'timeout' => 10,
        'httpversion' => '1.1',
        'body' => $bodydatatosend,
        'headers' => array(
                'Auth-Id' => $api_username,
                'Auth-Token' => $token,
                'Timestamp' => $timestamp,
                'Content-Type' => 'application/x-www-form-urlencoded'
            ),
        );
    $raw_response = wp_remote_request($url, $request_args);
            if (is_wp_error($raw_response)) {
            $request_args['sslverify'] = true;
            $raw_response = wp_remote_request($url, $request_args);

            if (is_wp_error($raw_response)) {
                return false;
            }
        }

        $json = wp_remote_retrieve_body($raw_response);
        $result = json_decode($json, true);
    if ($result['code'] == 200){
    update_post_meta($order_id, 'ke_status','success');
    }
    }
}

    
add_action( 'woocommerce_order_status_completed', 'g9_subke_order_completed', 10, 1 ); 
add_action( 'woocommerce_order_status_changed', 'g9_subke_order_change_to_completed', 10, 4 );
}

/* Create footer shortcode */
add_shortcode( 'g9ke', 'gaman_ke_shortcode' );
function gaman_ke_shortcode() {
ob_start();
if (get_option('g9kekey') && get_option('g9keuserid') && get_option('g9kesublistid')) {
if (isset($_REQUEST['subkefoot']) && check_admin_referer('g9kefootnonce')) {
        $url = 'https://api.kirim.email/v3/subscriber/';
        $timestamp = time();
        $api_username = get_option('g9keuserid');
        $api_token = get_option('g9kekey');
        $auth_str = rtrim(ltrim($api_username)) . "::" . rtrim(ltrim($api_token)) . "::" . $timestamp;
        $token = hash_hmac("sha256", $auth_str, rtrim(ltrim($api_token)));
        $email = $_REQUEST['g9keaddressfoot'];
        $listid = get_option('g9kesublistid');
        $bodydata = array(
        'lists' => $listid ,
        'full_name' => '',
        'email' => $email
        );
        $bodydatatosend = http_build_query($bodydata) . "\n";
        $request_args = array(
            'method' => 'POST',
            'sslverify' => false,
            'timeout' => 10,
            'httpversion' => '1.1',
            'body' => $bodydatatosend,
            'headers' => array(
                'Auth-Id' => $api_username,
                'Auth-Token' => $token,
                'Timestamp' => $timestamp,
                'Content-Type' => 'application/x-www-form-urlencoded'
            ),
        );
    $raw_response = wp_remote_request($url, $request_args);
            if (is_wp_error($raw_response)) {
            $request_args['sslverify'] = true;
            $raw_response = wp_remote_request($url, $request_args);

            if (is_wp_error($raw_response)) {
                return false;
            }
        }

        $json = wp_remote_retrieve_body($raw_response);
        $result = json_decode($json, true);
    if ($result['code'] == 200){
        echo '<div class="g9keupdated"><span style="color:green">Thank you for signing up!</span></div><br/>';
        if (get_option('g9keredirect')){$redirectdestination = 'Location: '.get_option('g9keredirect'); header($redirectdestination);die();}; 
    } else echo '<div class="g9keerror"><span style="color:red">S'.$result['message'].'</span></div><br/>';
}
?>
<form method="post">
<input type="email" aria-label="Input email address" placeholder="Email Address" name="g9keaddressfoot" class="g9keaddress">
<?php wp_nonce_field('g9kefootnonce'); ?>
<button type="submit"  name="subkefoot" class="g9kebutton">Subscribe</button>
</form>
<div style="clear:both"></div>
<?php
return ob_get_clean();
}
}

/* Create section shortcode */
add_shortcode( 'g9kesection', 'gaman_sectionke_shortcode' );
function gaman_sectionke_shortcode() {
ob_start();
if (get_option('g9kekey') && get_option('g9keuserid') && get_option('g9kesublistid')) {
if (isset($_REQUEST['subkesection']) && check_admin_referer('g9kesectionnonce')) {
        $url = 'https://api.kirim.email/v3/subscriber/';
        $timestamp = time();
        $api_username = get_option('g9keuserid');
        $api_token = get_option('g9kekey');
        $auth_str = rtrim(ltrim($api_username)) . "::" . rtrim(ltrim($api_token)) . "::" . $timestamp;
        $token = hash_hmac("sha256", $auth_str, rtrim(ltrim($api_token)));
        $email = $_REQUEST['g9keaddresssection'];
        $listid = get_option('g9kesublistid');
        $bodydata = array(
        'lists' => $listid ,
        'full_name' => '',
        'email' => $email
        );
        $bodydatatosend = http_build_query($bodydata) . "\n";
        $request_args = array(
            'method' => 'POST',
            'sslverify' => false,
            'timeout' => 10,
            'httpversion' => '1.1',
            'body' => $bodydatatosend,
            'headers' => array(
                'Auth-Id' => $api_username,
                'Auth-Token' => $token,
                'Timestamp' => $timestamp,
                'Content-Type' => 'application/x-www-form-urlencoded'
            ),
        );
    $raw_response = wp_remote_request($url, $request_args);
            if (is_wp_error($raw_response)) {
            $request_args['sslverify'] = true;
            $raw_response = wp_remote_request($url, $request_args);

            if (is_wp_error($raw_response)) {
                return false;
            }
        }

        $json = wp_remote_retrieve_body($raw_response);
        $result = json_decode($json, true);
    if ($result['code'] == 200){
        echo '<div class="g9keupdated"><span style="color:green">Thank you for signing up!</span></div><br/>';
        if (get_option('g9keredirect')){$redirectdestination = 'Location: '.get_option('g9keredirect'); header($redirectdestination);die();}; 
    } else echo '<div class="g9keerror"><span style="color:red">S'.$result['message'].'</span></div><br/>';
}
?>
<form method="post">
<input type="email" aria-label="Input email address" placeholder="Email Address" name="g9keaddresssection" class="g9keaddress">
<?php wp_nonce_field('g9kesectionnonce'); ?>
<button type="submit"  name="subkesection" class="g9kebutton">Subscribe</button>
</form>
<div style="clear:both"></div>
<?php
return ob_get_clean();
}
}

/* Create page shortcode */
add_shortcode( 'g9kepage', 'gaman_pageke_shortcode' );
function gaman_pageke_shortcode() {
ob_start();
if (get_option('g9kekey') && get_option('g9keuserid') && get_option('g9kesublistid')) {
if (isset($_REQUEST['subkepage']) && check_admin_referer('g9kepagenonce')) {
        $url = 'https://api.kirim.email/v3/subscriber/';
        $timestamp = time();
        $api_username = get_option('g9keuserid');
        $api_token = get_option('g9kekey');
        $auth_str = rtrim(ltrim($api_username)) . "::" . rtrim(ltrim($api_token)) . "::" . $timestamp;
        $token = hash_hmac("sha256", $auth_str, rtrim(ltrim($api_token)));
        $email = $_REQUEST['g9keaddresspage'];
        $listid = get_option('g9kesublistid');
        $bodydata = array(
        'lists' => $listid ,
        'full_name' => '',
        'email' => $email
        );
        $bodydatatosend = http_build_query($bodydata) . "\n";
        $request_args = array(
            'method' => 'POST',
            'sslverify' => false,
            'timeout' => 10,
            'httpversion' => '1.1',
            'body' => $bodydatatosend,
            'headers' => array(
                'Auth-Id' => $api_username,
                'Auth-Token' => $token,
                'Timestamp' => $timestamp,
                'Content-Type' => 'application/x-www-form-urlencoded'
            ),
        );
    $raw_response = wp_remote_request($url, $request_args);
            if (is_wp_error($raw_response)) {
            $request_args['sslverify'] = true;
            $raw_response = wp_remote_request($url, $request_args);

            if (is_wp_error($raw_response)) {
                return false;
            }
        }

        $json = wp_remote_retrieve_body($raw_response);
        $result = json_decode($json, true);
    if ($result['code'] == 200){
        echo '<div class="g9keupdated"><span style="color:green">Thank you for signing up!</span></div><br/>';
        if (get_option('g9keredirect')){$redirectdestination = 'Location: '.get_option('g9keredirect'); header($redirectdestination);die();}; 
    } else echo '<div class="g9keerror"><span style="color:red">S'.$result['message'].'</span></div><br/>';
}
?>
<div class="g9keform" style="max-width:<?php echo get_option('g9kepagewidth'); ?>px;margin:auto;margin-top:<?php echo get_option('g9kepagemargintop'); ?>px">
<form method="post">
<input type="email" aria-label="Input email address" placeholder="Email Address" name="g9keaddresspage" class="g9keaddress">
<?php wp_nonce_field('g9kepagenonce'); ?>
<button type="submit"  name="subkepage" class="g9kebutton">Subscribe</button>
</form>
<div style="clear:both"></div>
</div>
<?php
return ob_get_clean();
}
}

/* Load style on page */
function g9_ke_style() {
?>
<style>
<?php if(get_option('g9kesublistid')){echo '.g9kebutton {border:none;font-size:18px;color:'.get_option('g9kecolor').';background:'.get_option('g9kebg').';box-shadow: 0 0 0 1px '.get_option('g9kebg').'}';} ?>
.g9keupdated {width:calc(100% - 21px);border-left:3px solid green;background: #EFE;padding:9px }
.g9keerror {width:calc(100% - 21px);border-left:3px solid red;background: rgb(255,0,0,0.1);padding:9px }
.g9keaddress{border:none;font-size:18px;box-shadow: 0 0 0 1px #e3e3e3}
.g9kebutton{cursor:pointer;}
.g9kebutton:hover{background:#f1f1f1;color:#595959}
@media (max-width:359px){
.g9keaddress,.g9kebutton{display:block;max-width:calc(100% - 18px);margin:auto;margin-bottom:32px;padding:12px 0px 12px 0px}
}
@media (min-width:360px){
.g9kebutton {display:block;float:left;width:126px;padding:12px;margin-bottom:32px}
.g9keaddress{display:block;float:left;width:calc(100% - 162px);margin-right:12px;padding:12px;margin-bottom:32px}
}
</style>
<?php
}
add_action( 'wp_head','g9_ke_style',99);