<?php
/**
 * Plugin Name: Kirim Email Woocommerce
 * Version:     1.0
 * Description: Automatically send customers data to Kirim.Email services
 * Author:      9aman
 * Author URI: https://9aman.com/
 */

//  Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/* Create Plugin Option */
add_action('admin_menu', 'g9ke_option');
function g9ke_option(){
if ( current_user_can( 'setup_network' ) || current_user_can( 'manage_options' ) ) {
$g9ke_menu = add_submenu_page('options-general.php','Kirim Email','Kirim Email' ,'manage_options','gaman-ke-settings','g9ke_callback');
add_action( 'load-' . $g9ke_menu, 'g9ke_script' );
}
}

/* Call Plugin CSS and JS */
function g9ke_script() {
wp_enqueue_style( 'css-styles', plugin_dir_url( __FILE__ ) . 'css/style.css' );
wp_enqueue_script( 'html5kellycolorpicker', plugin_dir_url( __FILE__ ) . 'js/html5kellycolorpicker.min.js',array('jquery'),NULL);
}

/* Define Plugin Path */
function g9ke_path(){
$pluginurl = plugin_dir_url( __FILE__ );
$parsepluginurl = parse_url($pluginurl, PHP_URL_PATH);
$pluginpath = $_SERVER["DOCUMENT_ROOT"] . $parsepluginurl;
return $pluginpath;
};

/* Call Plugin Handler */
require_once( g9ke_path().'/handler/handler.php' );

/* Register Plugin settings */
add_action( 'admin_init', 'g9ke_field' );
function g9ke_field() {
register_setting("g9ke-group", "g9keexpired");
register_setting("g9ke-group", "g9kekey");
register_setting("g9ke-group", "g9keuserid");
register_setting("g9ke-group", "g9keredirect");
register_setting("g9ke-group", "g9kewoolistid");
register_setting("g9ke-group", "g9kesublistid");
register_setting("g9ke-group", "g9kecolor");
register_setting("g9ke-group", "g9kebg");
register_setting("g9ke-group", "g9kepagewidth");
register_setting("g9ke-group", "g9kepagemargintop");
}


/* Plugin settings callback */
function g9ke_callback() {
g9ke_activator();
if (get_option('g9keexpired')) {
echo '<div class="g9themeoptionbg"><div class="g9optfrm">';
if (isset($_REQUEST['connect_ke']) && check_admin_referer('g9kenonce')) {
update_option('g9kekey', $_REQUEST['g9kekey']);
update_option('g9keuserid', $_REQUEST['g9keuserid']);
update_option('g9keredirect', $_REQUEST['g9keredirect']);
update_option('g9kewoolistid', $_REQUEST['g9kewoolistid']);
update_option('g9kesublistid', $_REQUEST['g9kesublistid']);
update_option('g9kecolor', $_REQUEST['g9kecolor']);
update_option('g9kebg', $_REQUEST['g9kebg']);
update_option('g9kepagewidth', $_REQUEST['g9kepagewidth']);
update_option('g9kepagemargintop', $_REQUEST['g9kepagemargintop']);
echo '<div class="g9updated"><span style="color:green">Settings Saved</span></div><br/>';

}
if (isset($_REQUEST['disconnect_ke']) && check_admin_referer('g9kenonce')) {
update_option('g9kekey', '');
update_option('g9keuserid', '');
update_option('g9keredirect', '');
update_option('g9kewoolistid', '');
update_option('g9kesublistid', '');
update_option('g9kecolor', '');
update_option('g9kebg', '');
update_option('g9kepagewidth', '');
update_option('g9kepagemargintop', '');
echo '<div class="g9error"><span style="color:red">Kirim.Email Connection Reset</span></div><br/>'; 
}
?>
<form method="post">
<label for="g9kekey" class="g9commonlabel">Kirim.Email's Token</label>
<input type="password" style="padding:5px 0px 5px 12px" class="g9specialinput" name="g9kekey" id="g9kekey" value="<?php echo get_option('g9kekey'); ?>">
<br/>
<label for="g9keuserid" class="g9commonlabel">Kirim.Email's Username</label>
<input type="text" style="padding:5px 0px 5px 12px" class="g9specialinput" name="g9keuserid" id="g9keuserid" value="<?php echo get_option('g9keuserid'); ?>">
<br/>
<label for="g9keredirect" class="g9commonlabel">Subscription Success Page URL</label>
<input type="text" style="padding:5px 0px 5px 12px" class="g9specialinput" name="g9keredirect" id="g9keredirect" value="<?php echo get_option('g9keredirect'); ?>">
<br/>
<label for="g9kewoolistid" class="g9commonlabel">Kirim.Email Woocommerce List ID</label>
<input type="text" class="g9specialinput" name="g9kewoolistid" id="g9kewoolistid" value="<?php echo get_option('g9kewoolistid'); ?>">
<br/>
<label for="g9kesublistid" class="g9commonlabel">Kirim.Email Subscriber List ID</label>
<input type="text" class="g9specialinput" name="g9kesublistid" id="g9kesublistid" value="<?php echo get_option('g9kesublistid'); ?>">
<br/>
<div class="g9commonlabel">Button Style</div>
<table>
<tr>
<td><label for="g9kecolor" style="display:block;margin-top:5px;margin-bottom:5px">Text Color</label></td>
<td><label for="g9kebg" style="display:block;margin-top:5px;margin-bottom:5px">BG color</label></td>
</tr>
<tr>
<td><input type="text" class="inputintable colorpicker-custom" name="g9kecolor" id="g9kecolor" 
value="<?php  if (get_option('g9kecolor')){ echo get_option('g9kecolor'); } else { echo '#595959';} ; ?>"></td>
<td><input type="text" class="inputintable colorpicker-custom" name="g9kebg" id="g9kebg" 
value="<?php  if (get_option('g9kebg')){ echo get_option('g9kebg'); } else { echo '#f1f1f1';} ; ?>"></td>
</tr>
</table>
<div style="clear:both"></div>
<br/>
<div style="clear:both"></div>
<div class="g9commonlabel">Form in page style</div>
<table>
<tr>
<td><label for="g9kepagewidth" style="display:block;margin-top:5px;margin-bottom:5px">Form Width</label></td>
<td><label for="g9kepagemargintop" style="display:block;margin-top:5px;margin-bottom:5px">Form Top Space</label></td>
</tr>
<tr>
<td><input type="text" class="inputintable" name="g9kepagewidth" id="g9kepagewidth" 
value="<?php  if (get_option('g9kepagewidth')){ echo get_option('g9kepagewidth'); } else { echo '800';} ; ?>"></td>
<td><input type="text" class="inputintable" name="g9kepagemargintop" id="g9kepagemargintop" 
value="<?php  if (get_option('g9kepagemargintop')){ echo get_option('g9kepagemargintop'); } else { echo '32';} ; ?>"></td>
</tr>
</table>
<div style="clear:both"></div>
<div class="g9spacer"></div>
<?php wp_nonce_field('g9kenonce'); ?>
<button type="submit"  name="connect_ke" class="g9save">Save</button>
<button type="submit" class="g9delsection" name="disconnect_ke">Reset</button>
<div style="clear:both"></div>
</form>
</div></div>
<script>
var colorpickersCustom = KellyColorPicker.attachToInputByClass('colorpicker-custom', {alpha_slider : false, size : 150, popupClass : 'popup-kelly-color-custom'}); 
</script>
<?php
}
}

function g9ke_activator() {
/* Plugin Activation */
echo '<div class="g9themeoptionbg"><div class="g9optfrm">';
$g9ke_activation_key = '5e9867400eccb2.29776240';
$g9ke_activation_url = 'https://9aman.com';
if (isset($_REQUEST['g9ke_validator']) && check_admin_referer('g9ke-activator')) {
$g9ke_license_key = $_REQUEST['g9keserial'];
  $api_params = array(
            'slm_action' => 'slm_check',
            'secret_key' => $g9ke_activation_key,
            'license_key' => $g9ke_license_key
        );
$response = wp_remote_get(add_query_arg($api_params, $g9ke_activation_url), array('timeout' => 20, 'sslverify' => false));
$license_data = json_decode(wp_remote_retrieve_body($response));
if($license_data->result == 'error'){
	echo '<div class="g9error"><span style="color:red">Please enter valid serial number.</span></div><br/>';
}
else {
$expiredate = $license_data->date_expiry;
$todate = date("Y-m-d");
if ($todate < $expiredate ) { echo '<div class="g9updated"><span style="color:green">Validation Success</span></div><br/>'; update_option('g9keexpired', $expiredate);} 
else { echo '<div class="g9error"><span style="color:red">Your serial number was expired. Please renew</span></div><br/>'; delete_option('g9keexpired');}
}
}
?>
<form method="post">
<label for="g9keserial" class="g9commonlabel">Serial Number</label>
<input type="password" style="padding:5px 0px 5px 12px" class="g9specialinput" placeholder="Enter your serial number" name="g9keserial" id="g9keserial" value="<?php echo get_option('g9keexpired'); ?>">
<div style="clear:both"></div>
<div class="g9spacer"></div>
<?php wp_nonce_field('g9ke-activator'); ?>
<button type="submit"  name="g9ke_validator" class="g9save">Validate</button>
<div style="clear:both"></div>
</form>
<?php
echo '</div></div>';
/* END Plugin Activation */
}

if (get_option('g9keexpired')) {
/* Updater */
$api_url = 'https://9aman.com/api/';
$plugin_slug = basename(dirname(__FILE__));
// Take over the update check
add_filter('pre_set_site_transient_update_plugins', 'gaman_ke_check_update');

function gaman_ke_check_update ($checked_data) {
	global $api_url, $plugin_slug, $wp_version;
	
	//Comment out these two lines during testing.
	if (empty($checked_data->checked))
		return $checked_data;

	$args = array(
		'slug' => $plugin_slug,
		'version' => '1.0',
	);
	$request_string = array(
			'body' => array(
				'action' => 'basic_check', 
				'request' => serialize($args),
				'api-key' => md5(get_bloginfo('url'))
			),
			'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo('url')
		);
	
	// Start checking for an update
	$raw_response = wp_remote_post($api_url, $request_string);
	
	if (!is_wp_error($raw_response) && ($raw_response['response']['code'] == 200))
		$response = unserialize($raw_response['body']);
	
	if (is_object($response) && !empty($response)) // Feed the update data into WP updater
		$checked_data->response[$plugin_slug .'/'. $plugin_slug .'.php'] = $response;
	$todate = date("Y-m-d");
	$expdate = get_option('g9keexpired');
	if ($todate < $expdate ) {return $checked_data;}
}


// Take over the Plugin info screen
add_filter('plugins_api', 'gaman_ke_api_call', 10, 3);

function gaman_ke_api_call($def, $action, $args) {
	global $plugin_slug, $api_url, $wp_version;
	
	if (!isset($args->slug) || ($args->slug != $plugin_slug))
		return false;
	
	// Get the current version
	$plugin_info = get_site_transient('update_plugins');
	$current_version = '1.0';
	$args->version = $current_version;
	
	$request_string = array(
			'body' => array(
				'action' => $action, 
				'request' => serialize($args),
				'api-key' => md5(get_bloginfo('url'))
			),
			'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo('url')
		);
	
	$request = wp_remote_post($api_url, $request_string);
	
	if (is_wp_error($request)) {
		$res = new WP_Error('plugins_api_failed', __('An Unexpected HTTP Error occurred during the API request.</p> <p><a href="?" onclick="document.location.reload(); return false;">Try again</a>'), $request->get_error_message());
	} else {
		$res = unserialize($request['body']);
		
		if ($res === false)
			$res = new WP_Error('plugins_api_failed', __('An unknown error occurred'), $request['body']);
	}
	
	return $res;
}
}